/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.persistence;

import java.util.Collection;
import java.util.Set;

import org.ow2.bonita.definition.ClassData;
import org.ow2.bonita.definition.InternalProcess;
import org.ow2.bonita.facade.def.element.MetaData;
import org.ow2.bonita.facade.uuid.ActivityInstanceUUID;
import org.ow2.bonita.facade.uuid.ProcessDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;
import org.ow2.bonita.facade.uuid.TaskUUID;
import org.ow2.bonita.pvm.job.Timer;
import org.ow2.bonita.pvm.session.PvmDbSession;
import org.ow2.bonita.runtime.ActivityInstanceKey;
import org.ow2.bonita.runtime.InternalExecution;
import org.ow2.bonita.runtime.InternalInstance;
import org.ow2.bonita.runtime.ProcessInstanceKey;
import org.ow2.bonita.runtime.ProcessVersion;
import org.ow2.bonita.runtime.TaskRunTime;


public interface RuntimeDbSession extends PvmDbSession {

  InternalInstance getInstance(ProcessInstanceUUID instanceUUID);

  Set<InternalInstance> getInstances(ProcessDefinitionUUID processId);

  InternalProcess getProcess(ProcessDefinitionUUID processUUID);

  Set<TaskRunTime> getInstanceTasks(ProcessInstanceUUID instanceUUID);

  ProcessVersion getLastProcessVersion(String processId);


  InternalProcess findLatestProcessById(String subProcessId);

  ProcessInstanceKey getProcessInstanceKey(ProcessDefinitionUUID processUUID);

  ActivityInstanceKey getActivityInstanceKey(ProcessInstanceUUID instanceUUID,
      String activityName);

  Collection<Timer> getExecutionTimers(InternalExecution internalExecution);

  TaskRunTime getTask(TaskUUID taskUUID);

  InternalExecution getExecutionPointingOnNode(ActivityInstanceUUID activityUUID);

  Set<ProcessDefinitionUUID> getDependentProcesses(String className);
  //ProcessDependency getProcessDependency(ProcessDefinitionUUID processUUID);

  Collection<ClassData> getProcessClassDatas(ProcessDefinitionUUID processUUID);
  ClassData getGlobalClassData(String className);

  Set<Timer> getInstanceTimers(ProcessInstanceUUID instanceUUID);
  
  MetaData getMetaData(String key); 
}
