/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.bonita.persistence.db;

import java.util.Map;
import java.util.Set;

import org.ow2.bonita.facade.def.majorElement.ProcessFullDefinition;
import org.ow2.bonita.facade.runtime.ProcessFullInstance;
import org.ow2.bonita.facade.uuid.ProcessDefinitionUUID;
import org.ow2.bonita.facade.uuid.ProcessInstanceUUID;


public interface DbQuerierBuffer {

  //All methods returning a Collection must never return null!
  //In that case, an empty collection must be returned
  
  /**
   * INSTANCES
   */
  
  Map<ProcessInstanceUUID, ProcessFullInstance> getInstances();
  Set<ProcessFullInstance> getInstancesSet();
  ProcessFullInstance getInstance(ProcessInstanceUUID instanceUUID);
  boolean isInstanceRemoved(ProcessInstanceUUID instanceUUID);
  void addInstance(ProcessFullInstance instance);
  boolean containsInstance(ProcessInstanceUUID instanceUUID);
  void removeInstance(ProcessFullInstance instance);
  
  /**
   * PACKAGES
   */
  
  Map<ProcessDefinitionUUID, ProcessFullDefinition> getProcesses();
  Map<ProcessDefinitionUUID, ProcessFullDefinition> getProcesses(String packageId);
  Set<ProcessFullDefinition> getProcessesSet();
  ProcessFullDefinition getProcess(ProcessDefinitionUUID processUUID);
  boolean isProcessRemoved(ProcessDefinitionUUID processUUID);
  void addProcess(ProcessFullDefinition pack);
  boolean containsProcess(ProcessDefinitionUUID processUUID);
  void removeProcess(ProcessFullDefinition pack);
}


